## ausweisapp2 1.22.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13.0)

if(POLICY CMP0020)
	cmake_policy(SET CMP0020 NEW)
endif()

if(POLICY CMP0023)
	cmake_policy(SET CMP0023 NEW)
endif()

if(POLICY CMP0046)
	cmake_policy(SET CMP0046 NEW)
endif()

if(POLICY CMP0048)
	cmake_policy(SET CMP0048 NEW)
endif()

if(POLICY CMP0054)
	cmake_policy(SET CMP0054 NEW)
endif()

if(POLICY CMP0063)
	cmake_policy(SET CMP0063 NEW)
endif()

if(POLICY CMP0071)
	cmake_policy(SET CMP0071 NEW)
endif()

if(POLICY CMP0072)
	cmake_policy(SET CMP0072 NEW)
endif()

if(POLICY CMP0074)
	cmake_policy(SET CMP0074 NEW)
endif()

if(POLICY CMP0076)
	cmake_policy(SET CMP0076 NEW)
endif()

# "tools.only" can be defined to disable the normal build and enable
# cmdline "tools" only. For example: "make format" or "make package_source"
if(tools.only)
	set(LANGUAGES NONE)
else()
	set(LANGUAGES CXX)
endif()

if(UNIX AND NOT IOS)
	set(CMAKE_OSX_DEPLOYMENT_TARGET 10.13 CACHE STRING "Required macOS version")
endif()

project(AusweisApp2 VERSION 1.22.0 LANGUAGES ${LANGUAGES})

# Set TWEAK if not defined in PROJECT_VERSION above to
# have a valid tweak version without propagating it
if(NOT PROJECT_VERSION_TWEAK)
	set(PROJECT_VERSION_TWEAK 0)
endif()

if(APPLE AND CMAKE_VERSION VERSION_GREATER_EQUAL "3.16" AND NOT tools.only)
	enable_language(OBJCXX)
endif()

if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT AND (IOS OR ANDROID))
	set(CMAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/dist" CACHE PATH "default install path" FORCE)
endif()
set(CMAKE_DIR "${PROJECT_SOURCE_DIR}/cmake")
set(CMAKE_MODULE_PATH "${CMAKE_DIR}")
option(BUILD_SHARED_LIBS "Enable build of shared libraries")
option(INTEGRATED_SDK "Build platform specific SDK" OFF)

include(Helper)

if(NOT VENDOR)
	set(VENDOR_FILE "${PROJECT_SOURCE_DIR}/vendor.txt")
	if(EXISTS "${VENDOR_FILE}")
		file(READ "${VENDOR_FILE}" VENDOR)
		string(STRIP "${VENDOR}" VENDOR)
	elseif(LINUX OR BSD)
		set(VENDOR "") # Qt uses Organization for pathes
	else()
		set(VENDOR AusweisApp2_CE) # CommunityEdition
	endif()
endif()
if(VENDOR MATCHES "Governikus")
	set(VENDOR_GOVERNIKUS TRUE)
	set(LICENSE_FILE "${PROJECT_SOURCE_DIR}/LICENSE.officially.txt")
else()
	set(LICENSE_FILE "${PROJECT_SOURCE_DIR}/LICENSE.txt")
endif()

message(STATUS "VENDOR: ${VENDOR}")
message(STATUS "VERSION: ${PROJECT_VERSION}")

if(ANDROID)
	if(NOT BUILD_PREVIEW)
		set(BUILD_PREVIEW false)
	endif()
	message(STATUS "BUILD_PREVIEW: ${BUILD_PREVIEW}")

	if(NOT ANDROID_VERSION_CODE)
		set(ANDROID_VERSION_CODE 0)
	endif()
	message(STATUS "ANDROID_VERSION_CODE: ${ANDROID_VERSION_CODE}")
endif()

if(IOS)
	if(NOT USE_DISTRIBUTION_PROFILE)
		set(USE_DISTRIBUTION_PROFILE false)
	endif()
	message(STATUS "USE_DISTRIBUTION_PROFILE: ${USE_DISTRIBUTION_PROFILE}")
endif()

if("${PROJECT_BINARY_DIR}" STREQUAL "${PROJECT_SOURCE_DIR}" AND NOT FORCE_SOURCE_BUILD)
	message(FATAL_ERROR "in tree building is not supported!")
endif()

if(CMAKE_BUILD_TYPE)
	string(TOUPPER ${CMAKE_BUILD_TYPE} CMAKE_BUILD_TYPE)
else()
	set(CMAKE_BUILD_TYPE "DEBUG" CACHE STRING "build type configuration" FORCE)
endif()

set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(SRC_DIR ${PROJECT_SOURCE_DIR}/src)
set(TEST_DIR ${PROJECT_SOURCE_DIR}/test)
set(DOCS_DIR ${PROJECT_SOURCE_DIR}/docs)
set(RESOURCES_DIR ${PROJECT_SOURCE_DIR}/resources)
set(PACKAGING_DIR ${RESOURCES_DIR}/packaging)
set(COPYRIGHT_TEXT "2014-2020 ${VENDOR}")
if(APPLE)
	string(REPLACE " \& " " \&amp; " COPYRIGHT_TEXT ${COPYRIGHT_TEXT})
endif()
set(BUNDLE_IDENTIFIER com.governikus.ausweisapp2)

include(Tools)
include(DVCS)
add_subdirectory(docs)

include(DefaultFiles)
include(Appcast)
include(Messages)
if(tools.only)
	include(Packaging)
	return()
endif()

if(CMAKE_BUILD_TYPE STREQUAL "DEBUG")
	set(VALGRIND_SUPPRESSIONS "${CMAKE_PREFIX_PATH}/test/valgrind.supp")
	if(NOT EXISTS "${VALGRIND_SUPPRESSIONS}")
		set(VALGRIND_SUPPRESSIONS "${CMAKE_SOURCE_DIR}/libs/test/valgrind.supp")
	endif()
	message(STATUS "Using valgrind suppressions: ${VALGRIND_SUPPRESSIONS}")
	set(VALGRIND_COMMAND_OPTIONS "--tool=memcheck --leak-check=full --show-leak-kinds=definite --errors-for-leak-kinds=definite --error-exitcode=1 --gen-suppressions=all --suppressions=${VALGRIND_SUPPRESSIONS}")

	include(CTest)
	configure_file("${CMAKE_DIR}/CTestCustom.cmake.in" "${CMAKE_BINARY_DIR}/CTestCustom.cmake" @ONLY)

	set(SONAR_CACHE_DIR ${CMAKE_BINARY_DIR}/../sonar_cache)
	if(NOT EXISTS "${SONAR_CACHE_DIR}")
		set(SONAR_CACHE_DIR ${CMAKE_BINARY_DIR})
	endif()
	get_filename_component(SONAR_CACHE_DIR ${SONAR_CACHE_DIR} ABSOLUTE)
	configure_file("${RESOURCES_DIR}/sonar-project.properties.in" "${CMAKE_BINARY_DIR}/sonar-project.properties" @ONLY)
endif()

include(Libraries)
include(CompilerFlags)

if(LINUX OR BSD)
	include(GNUInstallDirs)
endif()

add_subdirectory(resources)
add_subdirectory(src)
add_subdirectory(test)

if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/utils")
	add_subdirectory(utils)
endif()

include(Packaging)

=== docs/CMakeLists.txt ===
if(SPHINX_FOUND)
	SPHINX_GEN("${CMAKE_CURRENT_SOURCE_DIR}/releasenotes" "notes" BUILDER singlehtml html latex)

	SPHINX_GEN("${CMAKE_CURRENT_SOURCE_DIR}/sdk" "sdk" BUILDER changes html latex DEFAULT_LANG en)

	SPHINX_GEN("${CMAKE_CURRENT_SOURCE_DIR}/installation" "inst" BUILDER changes html latex)

	SPHINX_GEN("${CMAKE_CURRENT_SOURCE_DIR}/integration" "inte" BUILDER changes html latex)
else()
	message(STATUS "No documentation will be generated")
endif()

=== libs/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8.0)

if(POLICY CMP0010)
	cmake_policy(SET CMP0010 NEW)
endif()

if(POLICY CMP0020)
	cmake_policy(SET CMP0020 NEW)
endif()

if(NOT ANDROID AND NOT IOS)
	set(COMPILER_SEARCH C CXX)
endif()

project(AusweisApp2_Libs ${COMPILER_SEARCH})

set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/../cmake")
include(ExternalProject)
include(Helper)
include(DVCS)


if(MSVC)
	find_program(MAKE nmake CMAKE_FIND_ROOT_PATH_BOTH)
else()
	find_program(MAKE make CMAKE_FIND_ROOT_PATH_BOTH)
endif()

if(MINGW AND NOT MAKE)
	find_program(MAKE mingw32-make CMAKE_FIND_ROOT_PATH_BOTH)
endif()

if(MAKE)
	message(STATUS "Using 'make' command... ${MAKE}")
else()
	message(FATAL_ERROR "Cannot find 'make' command")
endif()

if(NOT DEFINED PROCESSOR_COUNT)
	include(ProcessorCount)
	ProcessorCount(PROCESSOR_COUNT)
endif()

if(NOT PROCESSOR_COUNT EQUAL 0 AND NOT "${MAKE}" MATCHES "nmake")
	set(MAKE_JOBS -j${PROCESSOR_COUNT})
	message(STATUS "PROCESSOR_COUNT: ${PROCESSOR_COUNT}")
endif()

if(CMAKE_BUILD_TYPE)
	string(TOUPPER ${CMAKE_BUILD_TYPE} CMAKE_BUILD_TYPE)
else()
	set(CMAKE_BUILD_TYPE "DEBUG" CACHE STRING "build type configuration" FORCE)
endif()

if(NOT ${CMAKE_BUILD_TYPE} STREQUAL "DEBUG" AND NOT ${CMAKE_BUILD_TYPE} STREQUAL "RELEASE" AND NOT ${CMAKE_BUILD_TYPE} STREQUAL "RELWITHDEBINFO")
	message(FATAL_ERROR "CMAKE_BUILD_TYPE is invalid! Available options: RELEASE, RELWITHDEBINFO, DEBUG")
endif()

if(MSVC)
	FIND_HOST_PACKAGE(Perl REQUIRED)
else()
	set(PERL_EXECUTABLE perl)
endif()

set(PATCH_CMAKE ${CMAKE_CURRENT_BINARY_DIR}/patch.cmake)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/patch.cmake.in ${PATCH_CMAKE} @ONLY)

if(NOT DESTINATION_DIR)
	set(DESTINATION_DIR ${PROJECT_BINARY_DIR}/dist)
endif()

configure_file(${PROJECT_SOURCE_DIR}/test/valgrind.supp.${CMAKE_BUILD_TYPE} ${DESTINATION_DIR}/test/valgrind.supp COPYONLY)

if(NOT PACKAGES_DIR)
	set(PACKAGES_DIR $ENV{PACKAGES_DIR})
	if(NOT PACKAGES_DIR)
		message(STATUS "Define PACKAGES_DIR for local packages")
		set(PACKAGES_DIR ${PROJECT_BINARY_DIR}/download)
	endif()
endif()

string(REPLACE "\\" "/" PACKAGES_DIR ${PACKAGES_DIR})
set_directory_properties(PROPERTIES EP_PREFIX ${CMAKE_CURRENT_BINARY_DIR}/b)
include(Messages)

if(NOT CMAKE_HOST_SYSTEM_NAME STREQUAL CMAKE_SYSTEM_NAME)
	get_filename_component(compiler "${CMAKE_CXX_COMPILER}" NAME)
	string(REGEX REPLACE "[a-z|+]+$" "" CROSS_PREFIX "${compiler}")
endif()

################################## Versions
set(QT 5.15.2)
set(QT_HASH 3a530d1b243b5dec00bc54937455471aaa3e56849d2593edb8ded07228202240)

set(OPENSSL 1.1.1h)
set(OPENSSL_HASH 5c9ca8774bd7b03e5784f26ae9e9e6d749c9da2438545077e6b3d755a06595d9)

################################## Files
set(QT_FILE qt-everywhere-src-${QT}.tar.xz)
set(OPENSSL_FILE openssl-${OPENSSL}.tar.gz)

################################## Downloads
if("${QT}" MATCHES "alpha|beta|rc")
	set(QT_DEST_DIR development_releases)
else()
	set(QT_DEST_DIR archive) # official_releases
endif()

string(REPLACE "." ";" QT_VERSION_LIST ${QT})
list(GET QT_VERSION_LIST 0 QT_MAJOR_VERSION)
list(GET QT_VERSION_LIST 1 QT_MINOR_VERSION)
set(QT_SUBVERSION ${QT_MAJOR_VERSION}.${QT_MINOR_VERSION})
set(QT_URL https://download.qt.io/${QT_DEST_DIR}/qt/${QT_SUBVERSION}/${QT}/single/${QT_FILE})

set(OPENSSL_SOURCE https://www.openssl.org/source)
if("${OPENSSL}" MATCHES "SNAP")
	list(APPEND OPENSSL_URLS ${OPENSSL_SOURCE}/snapshot/${OPENSSL_FILE})
else()
	string(SUBSTRING ${OPENSSL} 0 5 OPENSSL_SUBVERSION)
	list(APPEND OPENSSL_URLS ${OPENSSL_SOURCE}/${OPENSSL_FILE})
	list(APPEND OPENSSL_URLS ${OPENSSL_SOURCE}/old/${OPENSSL_SUBVERSION}/${OPENSSL_FILE})
endif()



set(ENABLED_TARGETS)

################################## OpenSSL
#########################################################################
list(APPEND ENABLED_TARGETS openssl)

set(OPENSSL_CONFIGURE_FLAGS no-camellia no-bf no-aria no-seed no-poly1305 no-srp no-gost no-idea no-mdc2 no-rc2 no-rc4 no-rc5 no-srtp no-hw no-sm2 no-sm3 no-sm4)
set(OPENSSL_CONFIGURE_FLAGS ${OPENSSL_CONFIGURE_FLAGS} no-ct no-dgram no-cast no-chacha no-blake2 no-rmd160 no-scrypt no-siphash no-whirlpool no-md4 no-des)
set(OPENSSL_CONFIGURE_FLAGS ${OPENSSL_CONFIGURE_FLAGS} no-tls1 no-tls1-method no-tls1_1 no-tls1_1-method no-tls1_3 no-ssl3 no-ssl3-method no-dtls no-dtls1-method no-dtls1_2-method)
set(OPENSSL_CONFIGURE_FLAGS ${OPENSSL_CONFIGURE_FLAGS} no-deprecated no-engine no-async no-dso no-comp no-ts no-makedepend no-tests shared)

if(${CMAKE_BUILD_TYPE} STREQUAL "DEBUG")
	set(OPENSSL_CONFIGURE_FLAGS --debug ${OPENSSL_CONFIGURE_FLAGS})
	if(MSVC)
		ADD_FLAG(/Od NOQUOTES VAR OPENSSL_COMPILER_FLAGS)
	endif()
else()
	set(OPENSSL_CONFIGURE_FLAGS no-ui-console no-filenames ${OPENSSL_CONFIGURE_FLAGS})
	ADD_FLAG(-Os NOQUOTES VAR OPENSSL_COMPILER_FLAGS)
endif()

ADD_FLAG(-fstack-protector-strong -fstack-protector NOQUOTES VAR OPENSSL_COMPILER_FLAGS)

if(IOS)
	if(CMAKE_OSX_ARCHITECTURES STREQUAL "x86_64")
		set(OPENSSL_ARCH iossimulator-xcrun)
		set(OPENSSL_CONFIGURE_FLAGS ${OPENSSL_CONFIGURE_FLAGS} no-asm)
	else()
		set(OPENSSL_ARCH ios64-cross)
		string(REGEX REPLACE "/SDKs/.*" "" CROSS_TOP_DEV_ROOT "${CMAKE_OSX_SYSROOT}")
		set(OPENSSL_ENV export CROSS_TOP=${CROSS_TOP_DEV_ROOT} && export CROSS_SDK=iPhoneOS.sdk &&)
	endif()
elseif(APPLE)
	set(OPENSSL_ARCH darwin64-x86_64-cc)
	set(OPENSSL_COMPILER_FLAGS ${OPENSSL_COMPILER_FLAGS} -mmacosx-version-min=10.13)
elseif(MINGW)
	set(OPENSSL_ARCH mingw)

	if(CMAKE_HOST_SYSTEM_NAME STREQUAL "Linux")
		set(OPENSSL_CONFIGURE_FLAGS ${OPENSSL_CONFIGURE_FLAGS} --cross-compile-prefix=${CROSS_PREFIX})
	endif()
elseif(MSVC)
	set(OPENSSL_CONFIGURE_FLAGS ${OPENSSL_CONFIGURE_FLAGS} no-asm)
	if(CMAKE_SIZEOF_VOID_P EQUAL 8)
		set(OPENSSL_ARCH VC-WIN64A)
	else()
		set(OPENSSL_ARCH VC-WIN32)
	endif()
elseif(ANDROID)
	if(CMAKE_ANDROID_ARCH_ABI STREQUAL "armeabi-v7a")
		set(OPENSSL_ARCH android-arm)
		set(OPENSSL_COMPILER_FLAGS ${OPENSSL_COMPILER_FLAGS} -mfloat-abi=softfp)
	elseif(CMAKE_ANDROID_ARCH_ABI STREQUAL "x86_64")
		set(OPENSSL_ARCH android-x86_64)
	elseif(CMAKE_ANDROID_ARCH_ABI STREQUAL "x86")
		set(OPENSSL_ARCH android-x86)
	elseif(CMAKE_ANDROID_ARCH_ABI STREQUAL "arm64-v8a")
		set(OPENSSL_ARCH android-arm64)
	else()
		message(FATAL_ERROR "CMAKE_ANDROID_ARCH_ABI not supported by openssl")
	endif()
	set(OPENSSL_CONFIGURE_FLAGS ${OPENSSL_CONFIGURE_FLAGS} no-stdio)

	get_filename_component(toolchain_bin "${CMAKE_C_COMPILER}" DIRECTORY)
	set(OPENSSL_ENV export PATH=${toolchain_bin}/:$ENV{PATH} &&)
	set(OPENSSL_ENV ${OPENSSL_ENV} export CC=clang && export CXX=clang++ &&)

	set(OPENSSL_COMPILER_FLAGS ${OPENSSL_COMPILER_FLAGS} -D__ANDROID_API__=${CMAKE_SYSTEM_VERSION})
elseif(BSD)
	set(OPENSSL_ARCH BSD-x86_64)
elseif(LINUX)
	if(CMAKE_SIZEOF_VOID_P EQUAL 8)
		set(OPENSSL_ARCH linux-x86_64)
	else()
		set(OPENSSL_ARCH linux-generic32)
	endif()
else()
	message(FATAL_ERROR "Unsupported system")
endif()

ExternalProject_Add(openssl
	URL ${OPENSSL_URLS}
	URL_HASH SHA256=${OPENSSL_HASH}
	DOWNLOAD_DIR ${PACKAGES_DIR}

	PATCH_COMMAND ${CMAKE_COMMAND} -DCOMPONENT=openssl -P ${PATCH_CMAKE}
	CONFIGURE_COMMAND ${OPENSSL_ENV} ${PERL_EXECUTABLE} <SOURCE_DIR>/Configure --prefix=${DESTINATION_DIR} ${OPENSSL_CONFIGURE_FLAGS} ${OPENSSL_ARCH} "${OPENSSL_COMPILER_FLAGS}"
	BUILD_COMMAND ${OPENSSL_ENV} ${MAKE} ${MAKE_JOBS}
	INSTALL_COMMAND ${OPENSSL_ENV} ${MAKE} ${MAKE_JOBS} install_sw
)

ExternalProject_Add_Step(openssl configdata
	COMMAND ${PERL_EXECUTABLE} configdata.pm --dump
	DEPENDEES configure
	DEPENDERS build
	WORKING_DIRECTORY <BINARY_DIR>)


if(MAC)
	set(OPENSSL_FILE_VERSION 1.1)
	add_custom_command(TARGET openssl POST_BUILD
		COMMAND install_name_tool -id libcrypto.${OPENSSL_FILE_VERSION}${CMAKE_SHARED_LIBRARY_SUFFIX} ${DESTINATION_DIR}/lib/libcrypto.${OPENSSL_FILE_VERSION}${CMAKE_SHARED_LIBRARY_SUFFIX}
		COMMAND install_name_tool -id libssl.${OPENSSL_FILE_VERSION}${CMAKE_SHARED_LIBRARY_SUFFIX} ${DESTINATION_DIR}/lib/libssl.${OPENSSL_FILE_VERSION}${CMAKE_SHARED_LIBRARY_SUFFIX}
		COMMAND install_name_tool -change ${DESTINATION_DIR}/lib/libcrypto.${OPENSSL_FILE_VERSION}${CMAKE_SHARED_LIBRARY_SUFFIX} libcrypto.${OPENSSL_FILE_VERSION}${CMAKE_SHARED_LIBRARY_SUFFIX} ${DESTINATION_DIR}/lib/libssl.${OPENSSL_FILE_VERSION}${CMAKE_SHARED_LIBRARY_SUFFIX})
endif()

if(IOS)
	# Remove this work-around! Do not build any .dylib or be able to use .dylib
	# Globbing is not supported by cmake command mode! This will work if executed with unix shell only.
	if(CMAKE_VERSION VERSION_LESS "3.17")
		add_custom_command(TARGET openssl POST_BUILD COMMAND ${CMAKE_COMMAND} -E remove ${DESTINATION_DIR}/lib/*.dylib)
	else()
		add_custom_command(TARGET openssl POST_BUILD COMMAND ${CMAKE_COMMAND} -E rm -f ${DESTINATION_DIR}/lib/*.dylib)
	endif()
elseif(ANDROID)
	if(CMAKE_VERSION VERSION_LESS "3.17")
		add_custom_command(TARGET openssl POST_BUILD COMMAND ${CMAKE_COMMAND} -E remove ${DESTINATION_DIR}/lib/*.a)
	else()
		add_custom_command(TARGET openssl POST_BUILD COMMAND ${CMAKE_COMMAND} -E rm -f ${DESTINATION_DIR}/lib/*.a)
	endif()
endif()

################################## Qt
#########################################################################
list(APPEND ENABLED_TARGETS qt)

if(${CMAKE_BUILD_TYPE} STREQUAL "DEBUG")
	if(APPLE)
		set(QT_CONFIGURE_FLAGS -debug-and-release) # debug-only framework builds are not supported on macOS
	else()
		set(QT_CONFIGURE_FLAGS -debug)
	endif()
	set(QT_CONFIGURE_FLAGS ${QT_CONFIGURE_FLAGS} -qml-debug)
else()
	set(QT_CONFIGURE_FLAGS -release -optimize-size -no-qml-debug)
	set(QT_CONFIGURE_FLAGS ${QT_CONFIGURE_FLAGS} $<$<CONFIG:RelWithDebInfo>:-force-debug-info>)
endif()

set(QT_CONFIGURE_FLAGS ${QT_CONFIGURE_FLAGS} -prefix ${DESTINATION_DIR} -opensource -confirm-license -recheck-all)
set(QT_CONFIGURE_FLAGS ${QT_CONFIGURE_FLAGS} -nomake examples -nomake tests -no-mtdev -no-dbus -no-harfbuzz -no-compile-examples -no-sql-sqlite)
set(QT_CONFIGURE_FLAGS ${QT_CONFIGURE_FLAGS} -qt-zlib -qt-libpng -qt-libjpeg -qt-pcre)
set(QT_CONFIGURE_FLAGS ${QT_CONFIGURE_FLAGS} -system-proxies -openssl-linked -I ${DESTINATION_DIR}/include -L ${DESTINATION_DIR}/lib)

if(CMAKE_CXX_COMPILER_LAUNCHER STREQUAL "ccache")
	set(QT_CONFIGURE_FLAGS ${QT_CONFIGURE_FLAGS} -ccache)
endif()


list(APPEND NO_FEATURES dtls winrt_bt ftp lcdnumber mdiarea)
list(APPEND NO_FEATURES hijricalendar islamiccivilcalendar jalalicalendar)
list(APPEND NO_FEATURES native-win32-bluetooth testlib_selfcover)
list(APPEND NO_FEATURES calendarwidget colordialog cups dial fontcombobox fontdialog)
list(APPEND NO_FEATURES imageformat_bmp imageformat_ppm imageformat_xbm)
list(APPEND NO_FEATURES sharedmemory textodfwriter bearermanagement)
list(APPEND NO_FEATURES undocommand undogroup undostack undoview)
list(APPEND NO_FEATURES printer printdialog printpreviewdialog printpreviewwidget)
list(APPEND NO_FEATURES splashscreen syntaxhighlighter dom sql qdoc)
foreach(feature ${NO_FEATURES})
	set(QT_CONFIGURE_FLAGS ${QT_CONFIGURE_FLAGS} -no-feature-${feature})
endforeach()


list(APPEND SKIP_MODULES qtwebglplugin qtscxml qtxmlpatterns qtwebchannel)
list(APPEND SKIP_MODULES qtwebengine qtscript qtactiveqt qtlocation qtserialbus)
list(APPEND SKIP_MODULES qtserialport qtgamepad qtvirtualkeyboard qtcanvas3d qtcharts)
list(APPEND SKIP_MODULES qtdatavis3d qt3d qtpurchasing qtwayland qtremoteobjects)
list(APPEND SKIP_MODULES qtspeech qtwebview multimedia qtquickcontrols qtlottie qtquick3d)
foreach(module ${SKIP_MODULES})
	set(QT_CONFIGURE_FLAGS_SKIP_MODULES ${QT_CONFIGURE_FLAGS_SKIP_MODULES} -skip ${module})
endforeach()


set(QT_CONFIGURE_FLAGS_OTHER -no-journald -no-directfb -no-linuxfb)
set(QT_CONFIGURE configure)
if(IOS)
	set(QT_CONFIGURE_FLAGS ${QT_CONFIGURE_FLAGS} ${QT_CONFIGURE_FLAGS_OTHER} -xplatform macx-ios-clang)

	if(CMAKE_OSX_ARCHITECTURES STREQUAL "x86_64")
		set(QT_CONFIGURE_FLAGS ${QT_CONFIGURE_FLAGS} -sdk iphonesimulator)
	else()
		set(QT_CONFIGURE_FLAGS ${QT_CONFIGURE_FLAGS} -sdk iphoneos)
	endif()
elseif(APPLE)
	find_program(XCODE_SELECT xcode-select)
	if(NOT XCODE_SELECT)

=== src/CMakeLists.txt ===
#####################################################################
# The main component that will link all necessary modules and plugins
# into AusweisApp2 executable for the specific platform.
#
# This component includes a main entry point and command line
# parser only. Everything else will be included from sub-modules.
#####################################################################

add_subdirectory(external)
add_subdirectory(global)
add_subdirectory(secure_storage)
add_subdirectory(settings)

add_subdirectory(file_provider)
add_subdirectory(configuration)
add_subdirectory(network)

add_subdirectory(export)
add_subdirectory(card)
add_subdirectory(services)

add_subdirectory(ui)
add_subdirectory(activation)
add_subdirectory(remote_device)
add_subdirectory(workflows)
add_subdirectory(core)
add_subdirectory(init)

add_subdirectory(whitelist_client)

file(GLOB TRANSLATION_FILES ${RESOURCES_DIR}/translations/*.ts)

foreach(filepath ${TRANSLATION_FILES})
	get_filename_component(filename "${filepath}" NAME)
	string(REGEX MATCH "_(.*)\.ts$" _unused "${filename}")
	list(APPEND USED_TRANSLATIONS ${CMAKE_MATCH_1})
endforeach()

set_property(SOURCE ${TRANSLATION_FILES} PROPERTY OUTPUT_LOCATION ${CMAKE_CURRENT_BINARY_DIR}/translations)
foreach(locale ${USED_TRANSLATIONS})
	file(COPY ${QT_TRANSLATIONS_DIR} DESTINATION ${CMAKE_CURRENT_BINARY_DIR} FILES_MATCHING REGEX "qtbase_${locale}")
endforeach()

option(UPDATE_TRANSLATIONS "Update translations/*.ts files (WARNING: make clean will delete the *.ts files!)")
if(UPDATE_TRANSLATIONS)
	option(UPDATE_TRANSLATIONS_NO_OBSOLETE "Remove obsolete translations from translations/*.ts files )")

	set(LUPDATE_OPTIONS -extensions c,cpp,h,ui,m,mm,qml,js -no-ui-lines -locations none)
	if(UPDATE_TRANSLATIONS_NO_OBSOLETE)
		qt_create_translation(QM_FILES ${SRC_DIR} ${RESOURCES_DIR} ${TRANSLATION_FILES} OPTIONS ${LUPDATE_OPTIONS} -no-obsolete)
	else()
		qt_create_translation(QM_FILES ${SRC_DIR} ${RESOURCES_DIR} ${TRANSLATION_FILES} OPTIONS ${LUPDATE_OPTIONS})
	endif()

	add_custom_target(update.translations DEPENDS ${QM_FILES})
	message(WARNING "'make clean' will delete *.ts files!")
else()
	qt_add_translation(QM_FILES ${TRANSLATION_FILES})
endif()

CONFIGURE_DEFAULT_FILES(${CMAKE_CURRENT_BINARY_DIR})


if(IOS)
	if(NOT INTEGRATED_SDK)
		list(APPEND IOS_RESOURCES ${RESOURCES_DIR}/qml)
		list(APPEND IOS_RESOURCES ${RESOURCES_DIR}/packaging/ios/de.lproj)
		list(APPEND IOS_RESOURCES ${RESOURCES_DIR}/packaging/ios/launchscreen.storyboard)
		list(APPEND IOS_RESOURCES ${CMAKE_CURRENT_BINARY_DIR}/translations)
		list(APPEND IOS_RESOURCES ${CMAKE_CURRENT_BINARY_DIR}/config.json)

		# Attention: the file names correspond to values in the Info.plist
		if(BUILD_PREVIEW)
			message(FATAL_ERROR "iOS preview not implemented")
		elseif(IS_DEVELOPER_VERSION)
			set(IOS_APPICON_PATH "beta/")
		else()
			set(IOS_APPICON_PATH "")
		endif()

		list(APPEND IOS_RESOURCES ${RESOURCES_DIR}/images/ios/appIcons/${IOS_APPICON_PATH}Images.xcassets)
		list(APPEND IOS_RESOURCES ${RESOURCES_DIR}/packaging/ios/Settings.bundle)
		list(APPEND IOS_RESOURCES ${RCC})
		set_source_files_properties(${RCC} PROPERTIES GENERATED TRUE)
	endif()
endif()


set(MAIN_FILE main.cpp)
if(IOS)
	if(INTEGRATED_SDK)
		add_library(AusweisApp SHARED ${MAIN_FILE} ${IOS_RESOURCES} ${QM_FILES})
	else()
		add_executable(AusweisApp MACOSX_BUNDLE ${MAIN_FILE} ${IOS_RESOURCES} ${QM_FILES})
	endif()
elseif(ANDROID OR INTEGRATED_SDK)
	add_library(AusweisApp SHARED ${MAIN_FILE} ${QM_FILES})
else()
	add_executable(AusweisApp WIN32 ${MAIN_FILE} windows.rc ${QM_FILES})
endif()

add_dependencies(AusweisApp AusweisAppRcc)

target_link_libraries(AusweisApp PRIVATE AusweisAppInit)
if(ANDROID)
	set_target_properties(AusweisApp PROPERTIES OUTPUT_NAME "${PROJECT_NAME}_${CMAKE_ANDROID_ARCH_ABI}")
else()
	set_target_properties(AusweisApp PROPERTIES OUTPUT_NAME "${PROJECT_NAME}")
endif()

if(INTEGRATED_SDK AND NOT ANDROID)
	ADD_CONFIG_JSON_RESOURCE(CONFIG_JSON_SOURCE)
	ADD_OBJECT_LIBRARY(AusweisAppConfig ${CONFIG_JSON_SOURCE})
	target_link_libraries(AusweisApp PRIVATE AusweisAppConfig)
endif()


if(APPLE)
	set(MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION})
	set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION})
	set(MACOSX_BUNDLE_LONG_VERSION_STRING ${PROJECT_VERSION})
	set(MACOSX_BUNDLE_ICON_FILE "${PROJECT_NAME}.icns")
	set(MACOSX_BUNDLE_BUNDLE_NAME ${PROJECT_NAME})
	set(MACOSX_BUNDLE_GUI_IDENTIFIER "${BUNDLE_IDENTIFIER}")
	set(MACOSX_BUNDLE_COPYRIGHT "${COPYRIGHT_TEXT}")

	if(IOS AND INTEGRATED_SDK)
		set(MACOSX_FRAMEWORK_BUNDLE_VERSION ${PROJECT_VERSION})
		set(MACOSX_FRAMEWORK_SHORT_VERSION_STRING ${PROJECT_VERSION})
		set_target_properties(AusweisApp PROPERTIES MACOSX_FRAMEWORK_NAME ${PROJECT_NAME})
		set_target_properties(AusweisApp PROPERTIES MACOSX_FRAMEWORK_IDENTIFIER "${BUNDLE_IDENTIFIER}")
		set_target_properties(AusweisApp PROPERTIES MACOSX_FRAMEWORK_INFO_PLIST "${PACKAGING_DIR}/ios/Info.framework.plist.in")
	elseif(IOS)
		set_target_properties(AusweisApp PROPERTIES MACOSX_BUNDLE_INFO_PLIST "${PACKAGING_DIR}/ios/Info.plist.in")
	else()
		configure_file(${PACKAGING_DIR}/macos/Info.plist.in ${CMAKE_BINARY_DIR}/Info.plist @ONLY)
	endif()
endif()


if(IOS)
	get_target_property(QT_BUILD_TYPE ${Qt}::Core IMPORTED_CONFIGURATIONS)
	if(QT_BUILD_TYPE STREQUAL "DEBUG")
		set(qt_suffix "_debug")
	endif()

	target_link_libraries(AusweisApp PRIVATE OpenSSL::Crypto OpenSSL::SSL) # remove this if iOS uses shared libraries
	target_link_libraries(AusweisApp PRIVATE -L${QT_HOST_PREFIX}/plugins/platforms)
	target_link_libraries(AusweisApp PRIVATE -L${QT_HOST_PREFIX}/plugins/imageformats)
	target_link_libraries(AusweisApp PRIVATE -L${QT_HOST_PREFIX}/lib)
	target_link_libraries(AusweisApp PRIVATE ${Qt}::Core ${Qt}::Network)
	target_link_libraries(AusweisApp PRIVATE -lqtpcre2${qt_suffix} -lqios${qt_suffix})
	target_link_libraries(AusweisApp PRIVATE -l${Qt}ClipboardSupport${qt_suffix})

	target_link_libraries(AusweisApp PRIVATE "-lc++ -lz -lm")
	target_link_libraries(AusweisApp PRIVATE ${IOS_ASSETSLIBRARY} ${IOS_UIKIT} ${IOS_COREFOUNDATION} ${IOS_OPENGLES} ${IOS_FOUNDATION} ${IOS_QUARTZCORE} ${IOS_CORETEXT} ${IOS_COREGRAPHICS} ${IOS_SECURITY} ${IOS_NETWORK} ${IOS_MOBILECORESERVICES} ${IOS_AUDIOTOOLBOX} ${IOS_IMAGEIO} ${IOS_CORENFC} ${IOS_MESSAGEUI} ${IOS_STOREKIT})
	target_link_libraries(AusweisApp PRIVATE -Wl,-e,_qt_main_wrapper)

	if(TARGET ${Qt}::Qml)
		target_link_libraries(AusweisApp PRIVATE ${Qt}::Gui ${Qt}::Svg ${Qt}::Qml ${Qt}::Quick ${Qt}::QuickControls2 ${Qt}::QuickTemplates2 ${Qt}::QuickShapes)
		target_link_libraries(AusweisApp PRIVATE -lqtlibpng${qt_suffix} -lqsvg${qt_suffix} -lqjpeg${qt_suffix} -lqtfreetype${qt_suffix})
		target_link_libraries(AusweisApp PRIVATE -l${Qt}GraphicsSupport${qt_suffix} -l${Qt}FontDatabaseSupport${qt_suffix})
		qt_import_qml_plugins(AusweisApp PATH_TO_SCAN "${RESOURCES_DIR}/qml")
	endif()

	set_target_properties(AusweisApp PROPERTIES RESOURCE "${IOS_RESOURCES}")
	set_target_properties(AusweisApp PROPERTIES XCODE_ATTRIBUTE_SKIP_INSTALL "NO")
	set_target_properties(AusweisApp PROPERTIES XCODE_ATTRIBUTE_ASSETCATALOG_COMPILER_APPICON_NAME "AppIcon")
	set_target_properties(AusweisApp PROPERTIES XCODE_ATTRIBUTE_TARGETED_DEVICE_FAMILY "1,2")
	set_target_properties(AusweisApp PROPERTIES XCODE_ATTRIBUTE_CODE_SIGN_ENTITLEMENTS "${PACKAGING_DIR}/ios/AusweisApp2.entitlements")

	if(INTEGRATED_SDK)
		GET_PUBLIC_HEADER(AusweisAppUiFunctional PUBLIC_HEADER)
		target_sources(AusweisApp PUBLIC ${PUBLIC_HEADER})
		set_target_properties(AusweisApp PROPERTIES FRAMEWORK TRUE FRAMEWORK_VERSION C MACOSX_FRAMEWORK_IDENTIFIER ${BUNDLE_IDENTIFIER})
		set_target_properties(AusweisApp PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION} PUBLIC_HEADER ${PUBLIC_HEADER})
		set_target_properties(AusweisApp PROPERTIES XCODE_ATTRIBUTE_INSTALL_PATH "@rpath")
	else()
		if(USE_DISTRIBUTION_PROFILE)
			set(PROVISIONING_PROFILE_SPECIFIER "iOS Release (Distribution)")
			set(EXPORT_METHOD app-store)
			set(XCODE_ATTRIBUTE_CODE_SIGN_IDENTITY "iPhone Distribution: Governikus GmbH & Co. KG (G7EQCJU4BR)")
		else()
			set(PROVISIONING_PROFILE_SPECIFIER "iOS Development")
			set(EXPORT_METHOD development)
			set(XCODE_ATTRIBUTE_CODE_SIGN_IDENTITY "iPhone Developer: Marco von der Puetten (46ZK7WV8QR)")
		endif()
		set_target_properties(AusweisApp PROPERTIES XCODE_ATTRIBUTE_PROVISIONING_PROFILE_SPECIFIER ${PROVISIONING_PROFILE_SPECIFIER})
		set_target_properties(AusweisApp PROPERTIES XCODE_ATTRIBUTE_INSTALL_PATH "$(LOCAL_APPS_DIR)")
		set_target_properties(AusweisApp PROPERTIES XCODE_ATTRIBUTE_CODE_SIGN_IDENTITY ${XCODE_ATTRIBUTE_CODE_SIGN_IDENTITY})
	endif()

	# prevent xcode to convert multiple png files to tiff
	set_target_properties(AusweisApp PROPERTIES XCODE_ATTRIBUTE_COMBINE_HIDPI_IMAGES "NO")

	configure_file(${PACKAGING_DIR}/ios/exportOptions.plist.in ${CMAKE_BINARY_DIR}/exportOptions.plist @ONLY)
endif()

if(MAC)
	target_link_libraries(AusweisApp PRIVATE ${OSX_APPKIT})

	set(AUTOSTART_HELPER_NAME AutostartHelper)
	set(AUTOSTART_HELPER_FULL_NAME ${PROJECT_NAME}${AUTOSTART_HELPER_NAME})
	set(AUTOSTART_HELPER_SOURCES autostart_helper/main.mm)
	set(AUTOSTART_HELPER_BUNDLE_ID "com.governikus.AusweisApp2.${AUTOSTART_HELPER_NAME}")
	add_executable(${AUTOSTART_HELPER_FULL_NAME} MACOSX_BUNDLE ${AUTOSTART_HELPER_SOURCES})
	target_link_libraries(${AUTOSTART_HELPER_FULL_NAME} ${OSX_APPKIT})
	configure_file(${PACKAGING_DIR}/macos/autostart_helper/Info.plist.in ${CMAKE_CURRENT_BINARY_DIR}/AutostartHelperInfo.plist @ONLY)
	set_target_properties(${AUTOSTART_HELPER_FULL_NAME} PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_BINARY_DIR}/AutostartHelperInfo.plist)

endif()

if(ANDROID)
	target_link_libraries(AusweisApp PRIVATE ${Qt}::AndroidExtras)
	target_link_libraries(AusweisApp PRIVATE AusweisAppCardNfc)
	if(NOT INTEGRATED_SDK)
		target_link_libraries(AusweisApp PRIVATE AusweisAppActivationIntent)
	endif()
endif()

if(IOS)
	target_link_libraries(AusweisApp PRIVATE AusweisAppCardIos)
	if(NOT INTEGRATED_SDK)
		target_link_libraries(AusweisApp PRIVATE AusweisAppActivationCustomScheme)
	endif()
endif()

if(WIN32)
	target_link_libraries(AusweisApp PRIVATE ${WIN_DEFAULT_LIBS})
endif()

if(TARGET ${Qt}::Qml)
	target_link_libraries(AusweisApp PRIVATE AusweisAppUiQml)
endif()

if(ANDROID)
	target_link_libraries(AusweisApp PRIVATE AusweisAppUiAidl)
else()
	target_link_libraries(AusweisApp PRIVATE debug AusweisAppUiAidl)
endif()

if(DESKTOP)
	target_link_libraries(AusweisApp PRIVATE AusweisAppCardPcsc AusweisAppCardDrivers AusweisAppActivationWebservice)
endif()

if(INTEGRATED_SDK AND NOT ANDROID)
	target_link_libraries(AusweisApp PRIVATE AusweisAppUiFunctional)
endif()

if(NOT ANDROID AND NOT IOS AND NOT INTEGRATED_SDK)
	target_link_libraries(AusweisApp PRIVATE AusweisAppUiWebsocket)
endif()


include(Install)
include(FeatureSummary)
FEATURE_SUMMARY(WHAT ALL)

=== src/activation/CMakeLists.txt ===
#####################################################################
# The module activation is responsible to enable different kinds of
# eID activation. This interface will be implemented by plugins
# for the specific platform.
#####################################################################

add_subdirectory(base)

add_subdirectory(webservice)

if(TARGET ${Qt}::Gui)
	add_subdirectory(customscheme)
	add_subdirectory(intent)
endif()

=== src/card/CMakeLists.txt ===
#####################################################################
# The module card is responsible to handle all generic card commands
# (APDU).
#
# It provides an interface that can be implemented by plugins like
# PCSC or Android-NFC called ReaderManagerPlugIn.
# Also it provides a ReaderManager that can be used as a generic
# control interface. It handles access and commands to specific
# reader, cards and commands to the identity card.
#####################################################################

add_subdirectory(base)

if(DESKTOP)
	add_subdirectory(pcsc)
endif()

if(TARGET ${Qt}::Nfc)
	add_subdirectory(nfc)
endif()

if(IOS)
	add_subdirectory(ios)
endif()

add_subdirectory(drivers)

=== src/external/CMakeLists.txt ===
################################## http_parser
#########################################################################
function(PARSE_HTTP_PARSER_VERSION _include_dir _version)
	set(_file "${_include_dir}/http_parser.h")

	file(READ "${_file}" _file_content)
	if(_file_content)
		string(REGEX REPLACE ".*#define[\t ]+HTTP_PARSER_VERSION_MAJOR[\t ]+([0-9]+).*" "\\1" _major "${_file_content}")
		string(REGEX REPLACE ".*#define[\t ]+HTTP_PARSER_VERSION_MINOR[\t ]+([0-9]+).*" "\\1" _minor "${_file_content}")
		string(REGEX REPLACE ".*#define[\t ]+HTTP_PARSER_VERSION_PATCH[\t ]+([0-9]+).*" "\\1" _patch "${_file_content}")
		set(${_version} "${_major}.${_minor}.${_patch}" PARENT_SCOPE)
	endif()
endfunction()

function(PRINT_HTTP_PARSER _include_dir _lib_dir)
	PARSE_HTTP_PARSER_VERSION("${_include_dir}" _version)

	if(NOT EXISTS "${_lib_dir}")
		set(_lib_dir "INTERNAL")
	endif()

	message(STATUS "HttpParser: ${_lib_dir} (${_version})")
endfunction()

if(NOT CMAKE_VERSION VERSION_LESS "3.10")
	find_path(HTTP_PARSER_INCLUDE_DIR NAMES http_parser.h)
	find_library(HTTP_PARSER_LIBRARY NAMES http_parser libhttp_parser)

	if(HTTP_PARSER_INCLUDE_DIR)
		PARSE_HTTP_PARSER_VERSION("${HTTP_PARSER_INCLUDE_DIR}" _version)
		if(_version VERSION_LESS "2.8.0")
			message(STATUS "HttpParser (system) too old: ${_version}")
			unset(HTTP_PARSER_INCLUDE_DIR CACHE)
			unset(HTTP_PARSER_LIBRARY CACHE)
		else()
			include(FindPackageHandleStandardArgs)
			FIND_PACKAGE_HANDLE_STANDARD_ARGS(HTTP_PARSER REQUIRED_VARS HTTP_PARSER_INCLUDE_DIR HTTP_PARSER_LIBRARY)
			mark_as_advanced(HTTP_PARSER_INCLUDE_DIR HTTP_PARSER_LIBRARY)
		endif()
	endif()
endif()

if(HTTP_PARSER_FOUND)
	add_library(AusweisAppExternal::HttpParser UNKNOWN IMPORTED GLOBAL)
	set_target_properties(AusweisAppExternal::HttpParser PROPERTIES INTERFACE_INCLUDE_DIRECTORIES "${HTTP_PARSER_INCLUDE_DIR}")
	set_target_properties(AusweisAppExternal::HttpParser PROPERTIES IMPORTED_LINK_INTERFACE_LANGUAGES "C" IMPORTED_LOCATION "${HTTP_PARSER_LIBRARY}")

else()
	set(HTTP_PARSER_INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/http_parser")
	file(GLOB_RECURSE EXTERNAL_HTTP_PARSER_FILES ${HTTP_PARSER_INCLUDE_DIR}/*.cpp)
	add_library(AusweisAppExternalHttpParser ${EXTERNAL_HTTP_PARSER_FILES})
	target_include_directories(AusweisAppExternalHttpParser INTERFACE "$<BUILD_INTERFACE:${HTTP_PARSER_INCLUDE_DIR}>")

	if(IOS)
		set_target_properties(AusweisAppExternalHttpParser PROPERTIES ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
	endif()

	if(MSVC)
		set_property(TARGET AusweisAppExternalHttpParser APPEND_STRING PROPERTY COMPILE_FLAGS " /w")
	else()
		set_property(TARGET AusweisAppExternalHttpParser APPEND_STRING PROPERTY COMPILE_FLAGS " -w")
	endif()

	add_library(AusweisAppExternal::HttpParser ALIAS AusweisAppExternalHttpParser)
endif()


PRINT_HTTP_PARSER("${HTTP_PARSER_INCLUDE_DIR}" "${HTTP_PARSER_LIBRARY}")

=== src/init/CMakeLists.txt ===
#####################################################################
# The module init is responsible to bootstrap the appplication.
#####################################################################

ADD_PLATFORM_LIBRARY(AusweisAppInit)

target_link_libraries(AusweisAppInit ${Qt}::Core OpenSSL::Crypto AusweisAppGlobal AusweisAppCore)

if(NOT INTEGRATED_SDK)
	target_link_libraries(AusweisAppInit ${Qt}::Gui) # QGuiApplication
	if(DESKTOP)
		target_link_libraries(AusweisAppInit ${Qt}::Widgets) # QApplication
	endif()
endif()


function(CONFIGURE_CONFIG_H)
	if(VENDOR_GOVERNIKUS)
		set(VENDOR_DOMAIN governikus.com)
	else()
		set(VENDOR_DOMAIN)
	endif()

	if(VERSION_DVCS)
		set(VERSION ${VERSION_DVCS})
	else()
		set(VERSION ${PROJECT_VERSION})
	endif()

	set(PRODUCT ${PROJECT_NAME})

	configure_file(config.h.in config.h @ONLY)
endfunction()

CONFIGURE_CONFIG_H()

=== src/network/CMakeLists.txt ===
#####################################################################
# The module network is responsible for all raw network stuff and
# checks for TLS security.
#####################################################################

ADD_PLATFORM_LIBRARY(AusweisAppNetwork)

target_link_libraries(AusweisAppNetwork ${Qt}::Core ${Qt}::Network AusweisAppExternal::HttpParser AusweisAppGlobal AusweisAppSecureStorage AusweisAppSettings)

=== src/settings/CMakeLists.txt ===
#####################################################################
# The module settings is responsible for user settings.
# They will be stored with QSettings using platform specific format.
#
# Any user changeable settings will be saved and loaded by this
# module.
#####################################################################

ADD_PLATFORM_LIBRARY(AusweisAppSettings)

target_link_libraries(AusweisAppSettings ${Qt}::Core ${Qt}::Network ${Qt}::Concurrent OpenSSL::Crypto AusweisAppGlobal)

if(MAC)
	target_link_libraries(AusweisAppSettings ${OSX_APPKIT} ${OSX_SERVICEMANAGEMENT})
endif()

if(ANDROID)
	target_link_libraries(AusweisAppSettings ${Qt}::AndroidExtras)
endif()

=== test/helper/CMakeLists.txt ===
add_library(AusweisAppTestHelper INTERFACE)

add_subdirectory(common)
target_link_libraries(AusweisAppTestHelper INTERFACE AusweisAppTestHelperCommon)

if(TARGET AusweisAppRemoteDevice)
	add_subdirectory(remote_device)

	# TestModule detection misses indirect dependency currently
	target_link_libraries(AusweisAppTestHelper INTERFACE AusweisAppTestHelperRemoteDevice)
endif()

add_subdirectory(ui)

# TestModule detection misses indirect dependency currently
if(TARGET AusweisAppTestHelperUiWebsocket)
	target_link_libraries(AusweisAppTestHelper INTERFACE AusweisAppTestHelperUiWebsocket)
endif()

=== test/qml/CMakeLists.txt ===
ADD_QML_TEST_FILES()

set(MAIN_FILES QmlTestRunner.cpp)
if(ANDROID)
	add_library(QmlTestRunner SHARED ${MAIN_FILES})
else()
	add_executable(QmlTestRunner ${MAIN_FILES})
endif()

target_link_libraries(QmlTestRunner ${Qt}::QuickTest ${Qt}::Gui AusweisAppGlobal AusweisAppUiQml)

=== debian/changelog ===
ausweisapp2 (1.22.0-1) unstable; urgency=medium

  * New upstream release (Closes: #960568)
  * Add libqt5qmlworkerscript5 to Build-Depends in debian/control
  * Fix bogus and missing QML packages in Depends of binary
    package in debian/control (Closes: #970085)
  * Add patch to fix installation path of manpage

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Wed, 02 Dec 2020 21:18:30 +0100

=== debian/control ===
Source: ausweisapp2
Section: utils
Priority: optional
Maintainer: John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>
Build-Depends: debhelper-compat (= 12),
	       libhttp-parser-dev,
	       libpcsclite-dev,
	       libqt5qmlworkerscript5,
	       libqt5svg5-dev,
	       libqt5websockets5-dev,
	       libssl-dev,
	       libudev-dev,
	       pkg-config,
	       qtbase5-dev,
	       qtdeclarative5-dev,
	       qtquickcontrols2-5-dev,
	       qttools5-dev,
	       cmake
Standards-Version: 4.5.0
Homepage: https://www.ausweisapp.bund.de
Vcs-Browser: https://salsa.debian.org/debian/ausweisapp2
Vcs-Git: https://salsa.debian.org/debian/ausweisapp2.git

Package: ausweisapp2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, qml-module-qt-labs-platform, qml-module-qtqml, qml-module-qtqml-models2, qml-module-qtqml-statemachine, qml-module-qtgraphicaleffects, qml-module-qtquick-controls, qml-module-qtquick-controls2, qml-module-qtquick-layouts
Description: Official authentication app for German ID cards and residence permits
 This app is developed and issued by the German government to be
 used for online authentication with electronic German ID cards
 and residence titles. To use this app, a supported RFID card
 reader or compatible NFC smart phone is required.

## ausweisapp2 1.22.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -52,7 +52,7 @@
 	set(CMAKE_OSX_DEPLOYMENT_TARGET 10.13 CACHE STRING "Required macOS version")
 endif()
 
-project(AusweisApp2 VERSION 1.22.0 LANGUAGES ${LANGUAGES})
+project(AusweisApp2 VERSION 1.22.2 LANGUAGES ${LANGUAGES})
 
 # Set TWEAK if not defined in PROJECT_VERSION above to
 # have a valid tweak version without propagating it
@@ -132,7 +132,7 @@
 set(DOCS_DIR ${PROJECT_SOURCE_DIR}/docs)
 set(RESOURCES_DIR ${PROJECT_SOURCE_DIR}/resources)
 set(PACKAGING_DIR ${RESOURCES_DIR}/packaging)
-set(COPYRIGHT_TEXT "2014-2020 ${VENDOR}")
+set(COPYRIGHT_TEXT "2014-2021 ${VENDOR}")
 if(APPLE)
 	string(REPLACE " \& " " \&amp; " COPYRIGHT_TEXT ${COPYRIGHT_TEXT})
 endif()

=== libs/CMakeLists.txt ===
--- 
+++ 
@@ -92,8 +92,8 @@
 set(QT 5.15.2)
 set(QT_HASH 3a530d1b243b5dec00bc54937455471aaa3e56849d2593edb8ded07228202240)
 
-set(OPENSSL 1.1.1h)
-set(OPENSSL_HASH 5c9ca8774bd7b03e5784f26ae9e9e6d749c9da2438545077e6b3d755a06595d9)
+set(OPENSSL 1.1.1k)
+set(OPENSSL_HASH 892a0875b9872acd04a9fde79b1f943075d5ea162415de3047c327df33fbaee5)
 
 ################################## Files
 set(QT_FILE qt-everywhere-src-${QT}.tar.xz)
@@ -110,7 +110,8 @@
 list(GET QT_VERSION_LIST 0 QT_MAJOR_VERSION)
 list(GET QT_VERSION_LIST 1 QT_MINOR_VERSION)
 set(QT_SUBVERSION ${QT_MAJOR_VERSION}.${QT_MINOR_VERSION})
-set(QT_URL https://download.qt.io/${QT_DEST_DIR}/qt/${QT_SUBVERSION}/${QT}/single/${QT_FILE})
+list(APPEND QT_URLS https://download.qt.io/${QT_DEST_DIR}/qt/${QT_SUBVERSION}/${QT}/single/${QT_FILE})
+list(APPEND QT_URLS https://ftp.fau.de/qtproject/${QT_DEST_DIR}/qt/${QT_SUBVERSION}/${QT}/single/${QT_FILE})
 
 set(OPENSSL_SOURCE https://www.openssl.org/source)
 if("${OPENSSL}" MATCHES "SNAP")
@@ -159,7 +160,11 @@
 	set(OPENSSL_ARCH darwin64-x86_64-cc)
 	set(OPENSSL_COMPILER_FLAGS ${OPENSSL_COMPILER_FLAGS} -mmacosx-version-min=10.13)
 elseif(MINGW)
-	set(OPENSSL_ARCH mingw)
+	if(CMAKE_SIZEOF_VOID_P EQUAL 8)
+		set(OPENSSL_ARCH mingw64)
+	else()
+		set(OPENSSL_ARCH mingw)
+	endif()
 
 	if(CMAKE_HOST_SYSTEM_NAME STREQUAL "Linux")
 		set(OPENSSL_CONFIGURE_FLAGS ${OPENSSL_CONFIGURE_FLAGS} --cross-compile-prefix=${CROSS_PREFIX})
@@ -301,10 +306,3 @@
 	set(QT_CONFIGURE_FLAGS ${QT_CONFIGURE_FLAGS} ${QT_CONFIGURE_FLAGS_OTHER} -xplatform macx-ios-clang)
 
 	if(CMAKE_OSX_ARCHITECTURES STREQUAL "x86_64")
-		set(QT_CONFIGURE_FLAGS ${QT_CONFIGURE_FLAGS} -sdk iphonesimulator)
-	else()
-		set(QT_CONFIGURE_FLAGS ${QT_CONFIGURE_FLAGS} -sdk iphoneos)
-	endif()
-elseif(APPLE)
-	find_program(XCODE_SELECT xcode-select)
-	if(NOT XCODE_SELECT)

=== test/qt/CMakeLists.txt ===
function(GET_CAPITALIZED _out string)
	string(SUBSTRING "${string}" 0 1 _tmp1)
	string(SUBSTRING "${string}" 1 -1 _tmp2)
	string(TOUPPER "${_tmp1}" _tmp1)
	set(${_out} ${_tmp1}${_tmp2} PARENT_SCOPE)
endfunction()


function(GET_SNAKE_TO_CAMEL_CASE _out string)
	string(REPLACE "_" ";" string "${string}")
	foreach(entry ${string})
		GET_CAPITALIZED(entry "${entry}")
		set(_tmp "${_tmp}${entry}")
	endforeach()

	set(${_out} "${_tmp}" PARENT_SCOPE)
endfunction()


function(EXTRACT_MODULES _out_module _out_submodule filename)
	get_filename_component(dir "${filename}" DIRECTORY)

	# make unit test directory to cmake list
	string(REPLACE "${CMAKE_CURRENT_SOURCE_DIR}/" "" dir "${dir}")
	string(REPLACE "/" ";" dir "${dir}")

	# extract first subdirectory as module
	list(GET dir 0 MODULE)
	GET_SNAKE_TO_CAMEL_CASE(MODULE "${MODULE}")

	# extract second subdirectory as submodule if it exists
	list(LENGTH dir dir_len)
	if(dir_len GREATER 1)
		list(GET dir 1 SUBMODULE)
		GET_CAPITALIZED(SUBMODULE "${SUBMODULE}")
	endif()

	# return values: module is required, submodule optional
	set(${_out_module} ${MODULE} PARENT_SCOPE)
	set(${_out_submodule} ${SUBMODULE} PARENT_SCOPE)
endfunction()


function(GET_MODULE _out prefix filename)
	EXTRACT_MODULES(MODULE SUBMODULE "${filename}")

	if(TARGET "${prefix}${MODULE}${SUBMODULE}")
		set(${_out} "${prefix}${MODULE}${SUBMODULE}" PARENT_SCOPE)
	elseif(TARGET "${prefix}${MODULE}")
		set(${_out} "${prefix}${MODULE}" PARENT_SCOPE)
	endif()
endfunction()


function(ADD_TEST_EXECUTABLE testname)
	if(ANDROID)
		add_library(${testname} SHARED ${ARGN})
	else()
		add_executable(${testname} ${ARGN})
	endif()

	GET_MODULE(TESTMODULE "AusweisAppTestHelper" "${ARGN}")
	GET_MODULE(MODULE "AusweisApp" "${ARGN}")
	if(NOT MODULE)
		message(FATAL_ERROR "Cannot detect module: ${ARGN}")
	endif()

	target_link_libraries(${testname} ${Qt}::Test AusweisAppTestHelper QRC_FIXTURE_OBJ ${MODULE} ${TESTMODULE})

	if(INCOMPATIBLE_QT_COMPILER_FLAGS)
		set_source_files_properties(${ARGN} PROPERTIES COMPILE_OPTIONS ${INCOMPATIBLE_QT_COMPILER_FLAGS})
	endif()
endfunction()


function(SHOULD_SKIP_TEST _out filename)
	set(${_out} FALSE PARENT_SCOPE)
	string(REPLACE "${CMAKE_CURRENT_SOURCE_DIR}/" "" test "${sourcefile}")

	if(INTEGRATED_SDK AND (test MATCHES "ui/qml"
		OR test MATCHES "ui/websocket"
		OR test MATCHES "init/"
		OR test MATCHES "remote_device"
		OR test MATCHES "export"))
		set(${_out} TRUE PARENT_SCOPE)
		return()
	endif()

	if(IOS OR ANDROID)
		if(test MATCHES "card/pcsc"
			OR test MATCHES "card/drivers")
			set(${_out} TRUE PARENT_SCOPE)
			return()
		endif()
	endif()
endfunction()


function(ADD_TEST_EXECUTABLE_SUBDIR)
	file(GLOB_RECURSE TEST_FILES "*.cpp")

	foreach(sourcefile ${TEST_FILES})
		SHOULD_SKIP_TEST(SKIP "${sourcefile}")
		if(SKIP)
			continue()
		endif()

		EXTRACT_TESTNAME(TESTNAME ${sourcefile})
		ADD_TEST_EXECUTABLE(${TESTNAME} ${sourcefile})
		GET_TEST_CMDLINE(TEST_CMDLINE ${TESTNAME})
		add_test(${TESTNAME} ${TESTNAME} ${TEST_CMDLINE})
		set_tests_properties(${TESTNAME} PROPERTIES FAIL_REGULAR_EXPRESSION "nullptr parameter")
		set_tests_properties(${TESTNAME} PROPERTIES ENVIRONMENT "QT_ENABLE_REGEXP_JIT=0")

		if(TESTNAME MATCHES "UIPlugIn")
			set_tests_properties(${TESTNAME} PROPERTIES LABELS "ausweisapp" TIMEOUT 300)
		else()
			set_tests_properties(${TESTNAME} PROPERTIES LABELS "ausweisapp" TIMEOUT 120)
		endif()
	endforeach()
endfunction()



CONFIGURE_DEFAULT_FILES(${CMAKE_CURRENT_BINARY_DIR})

# Build single test binaries for each cpp file
ADD_TEST_EXECUTABLE_SUBDIR()

=== debian/changelog ===
ausweisapp2 (1.22.2-1) unstable; urgency=medium

  * New upstream release
  * Update Standards-Version to 4.5.1 in debian/control

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Sun, 08 Aug 2021 22:03:58 +0200

ausweisapp2 (1.22.1-1) unstable; urgency=medium

  * New upstream release
  * Drop 0001-Fix-installation-path-of-manpage.patch, fixed upstream

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Fri, 06 Aug 2021 08:22:18 +0200

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
 	       qtquickcontrols2-5-dev,
 	       qttools5-dev,
 	       cmake
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://www.ausweisapp.bund.de
 Vcs-Browser: https://salsa.debian.org/debian/ausweisapp2
 Vcs-Git: https://salsa.debian.org/debian/ausweisapp2.git

## ausweisapp2 1.22.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -40,6 +40,10 @@
 	cmake_policy(SET CMP0076 NEW)
 endif()
 
+if(POLICY CMP0092)
+	cmake_policy(SET CMP0092 NEW)
+endif()
+
 # "tools.only" can be defined to disable the normal build and enable
 # cmdline "tools" only. For example: "make format" or "make package_source"
 if(tools.only)
@@ -52,7 +56,7 @@
 	set(CMAKE_OSX_DEPLOYMENT_TARGET 10.13 CACHE STRING "Required macOS version")
 endif()
 
-project(AusweisApp2 VERSION 1.22.2 LANGUAGES ${LANGUAGES})
+project(AusweisApp2 VERSION 1.22.3 LANGUAGES ${LANGUAGES})
 
 # Set TWEAK if not defined in PROJECT_VERSION above to
 # have a valid tweak version without propagating it
@@ -132,7 +136,7 @@
 set(DOCS_DIR ${PROJECT_SOURCE_DIR}/docs)
 set(RESOURCES_DIR ${PROJECT_SOURCE_DIR}/resources)
 set(PACKAGING_DIR ${RESOURCES_DIR}/packaging)
-set(COPYRIGHT_TEXT "2014-2021 ${VENDOR}")
+set(COPYRIGHT_TEXT "2014-2022 ${VENDOR}")
 if(APPLE)
 	string(REPLACE " \& " " \&amp; " COPYRIGHT_TEXT ${COPYRIGHT_TEXT})
 endif()

=== libs/CMakeLists.txt ===
--- 
+++ 
@@ -92,8 +92,8 @@
 set(QT 5.15.2)
 set(QT_HASH 3a530d1b243b5dec00bc54937455471aaa3e56849d2593edb8ded07228202240)
 
-set(OPENSSL 1.1.1k)
-set(OPENSSL_HASH 892a0875b9872acd04a9fde79b1f943075d5ea162415de3047c327df33fbaee5)
+set(OPENSSL 1.1.1m)
+set(OPENSSL_HASH f89199be8b23ca45fc7cb9f1d8d3ee67312318286ad030f5316aca6462db6c96)
 
 ################################## Files
 set(QT_FILE qt-everywhere-src-${QT}.tar.xz)
@@ -146,6 +146,12 @@
 endif()
 
 ADD_FLAG(-fstack-protector-strong -fstack-protector NOQUOTES VAR OPENSSL_COMPILER_FLAGS)
+
+if(WIN32)
+	ADD_FLAG(-Wl,--dynamicbase VAR OPENSSL_COMPILER_FLAGS USE_SAME_FOR_LINKER)
+	ADD_FLAG(-Wl,--nxcompat VAR OPENSSL_COMPILER_FLAGS USE_SAME_FOR_LINKER)
+	ADD_FLAG(-Wl,--high-entropy-va VAR OPENSSL_COMPILER_FLAGS USE_SAME_FOR_LINKER)
+endif()
 
 if(IOS)
 	if(CMAKE_OSX_ARCHITECTURES STREQUAL "x86_64")
@@ -300,9 +306,3 @@
 endforeach()
 
 
-set(QT_CONFIGURE_FLAGS_OTHER -no-journald -no-directfb -no-linuxfb)
-set(QT_CONFIGURE configure)
-if(IOS)
-	set(QT_CONFIGURE_FLAGS ${QT_CONFIGURE_FLAGS} ${QT_CONFIGURE_FLAGS_OTHER} -xplatform macx-ios-clang)
-
-	if(CMAKE_OSX_ARCHITECTURES STREQUAL "x86_64")

=== debian/changelog ===
ausweisapp2 (1.22.3-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Thu, 27 Jan 2022 13:42:33 +0100

ausweisapp2 (1.22.3-1) unstable; urgency=medium

  * New upstream release
  * Update Standards-Version to 4.6.0 in debian/control

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Thu, 20 Jan 2022 10:14:21 +0100
